

-- add option to show, add and delete other players who may edit this npc;
-- add buttons for skin change and editing properties
local old_get_fs_initial_config = yl_speak_up.get_fs_initial_config
yl_speak_up.get_fs_initial_config = function(player, n_id, d_id, is_initial_config, add_formspec)
	-- nothing to add if this is the initial configuration
	if(is_initial_config) then
		return old_get_fs_initial_config(player, n_id, d_id, is_initial_config, nil)
	end

	local pname = player:get_player_name()
	local dialog = yl_speak_up.speak_to[pname].dialog
	-- dialog.n_may_edit was a string for a short time in development
	if(not(dialog.n_may_edit) or type(dialog.n_may_edit) ~= "table") then
		dialog.n_may_edit = {}
	end
	local table_of_names = dialog.n_may_edit
	local may_be_edited_by = {
		-- these buttons and formspecs are provided by the editor:
		"button[1.0,5.5;4,0.9;edit_skin;Edit Skin]",
		"button[6.0,5.5;4,0.9;edit_properties;Edit Properties]",
		-- who can edit this NPC?
		"label[0.2,4.75;May be edited by:]",
		-- offer a dropdown list and a text input field for player names for adding
		yl_speak_up.create_dropdown_playerlist(player, pname,
			table_of_names, yl_speak_up.speak_to[pname].tmp_index,
			3.0, 4.3, 0.0, 1.0, "list_may_edit", "player",
				"Remove selected\nplayer from list",
			"add_may_edit",
				"Enter the name of the player whom you\n"..
				"want to grant the right to edit your NPC.\n"..
				"The player needs at least the npc_talk_owner priv\n"..
				"in order to actually edit the NPC.\n"..
				"Click on \"Save\" to add the new player.",
			"delete_may_edit",
				"If you click here, the player will no\n"..
				"longer be able to edit your NPC."
		)}
	-- show the formspec to the player
	return old_get_fs_initial_config(player, n_id, d_id, is_initial_config, may_be_edited_by)
end
